;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
; Save-It.SC   (C) 1991, Dave Pipitone, Streamwood, IL
; This script IS FREEWARE and may be used by anyone and incorporated into
; any noncommercial program as the user sees fit.
;
; Save-it.sc saves a report or form specification while designing or changing
; a form or report.  The user is prompted to select the table name and enter
; the Form or Report spec.  The script will save the Form or Report and return
; the user to the same cursor position before invoking Save-it.
; I've assigned this script to ALT F1, using the SETKEY function in my Init.sc.
; (SETKEY -104 PLAY "Save-it", e.g.)
; Comments/suggestions for improvement are welcome.  Enjoy!
;DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
IF Sysmode()="Report"
THEN
  SHOWTABLES
        DIRECTORY()
       "Highlight the current table, and press Enter."
       TO Tablename.a
    IF retval=False
         THEN MESSAGE "You pressed [Esc] - Report not saved."
                       SLEEP 1500  QUIT
    ENDIF
   @2,0 CLEAR EOL
        ?? "Enter the Report Spec Number:  "
                ACCEPT "A3" PICTURE "R[#][#]" to Spec.a
    IF retval=False
         THEN @2,0 CLEAR EOL
              MESSAGE "Operation cancelled - Report "+spec.a+" not saved."
              SLEEP 1500  QUIT
    ENDIF
    @2,0 CLEAR EOL
    y=COLNO()
    CTRLHOME
    q=COLNO()
    Z=ROWNO()
    Do_it!
    ClearAll
    {Report}{Change} SELECT Tablename.a SELECT Spec.a Enter
    FOR i from 1 to y-q
      Right
    ENDFOR
    FOR i from 1 to Z-1
      Down
    ENDFOR
    MESSAGE "Report spec saved."   SLEEP 1500
      ELSE IF Sysmode()="Form"
              THEN
                 SHOWTABLES
                   DIRECTORY()
                  "Highlight the name of the current table, and press Enter."
                      TO Tablename.a
                IF retval="Esc"
                  THEN MESSAGE "You pressed [Esc], Form not saved."
                     SLEEP 1500  QUIT
                ENDIF
                @2,0 CLEAR EOL
                ?? "Enter the Form Spec Number:  "
                    ACCEPT "A3" PICTURE "F[#][#]" to Spec.a
                 IF retval=False
                       THEN @2,0 CLEAR EOL
                          MESSAGE "Operation cancelled - Form "+spec.a=" not saved."
                          SLEEP 1500 QUIT
                 ENDIF
               @2,0 CLEAR EOL
               y=COLNO()
               CTRLHOME
               q=COLNO()
               Z=ROWNO()
               Do_it!
               ClearAll
               {Forms}{Change} SELECT Tablename.a SELECT Spec.a Enter
                 FOR i from 1 to y-q
                    Right
                 ENDFOR
                 FOR i from 1 to Z-1
                    Down
                 ENDFOR
                 MESSAGE "Form spec saved."  SLEEP 1500
                    ELSE IF (Sysmode()<>"Form" OR Sysmode()<>"Report")
                            THEN
                              MESSAGE "Not in Report or Form mode."
                              SLEEP 1500 QUIT
                         ENDIF
            ENDIF
 ENDIF